<template>
  <div class="icon-small">
    <kinesis-container event="scroll" tag="div">
      <kinesis-element :strength="parallaxStrength" :origin-y="parallaxOrigin">
        <img :src="getImage('am-mary.svg')" alt="Santa Maria" />
      </kinesis-element>
    </kinesis-container>
  </div>
  <article class="slide-container">
    <base-scroll-animation :type="'fade'" :duration="2000" :once="true">
      <template v-slot:animate>
        <h2 class="title title:large font-black">
          W<span class="-ss02">O</span>R<span class="-ss02">K</span>
        </h2>
      </template>
    </base-scroll-animation>

    <div class="slider">
      <base-scroll-animation
        :type="'fade'"
        :duration="2500"
        :delay="500"
        :once="true"
      >
        <template v-slot:animate>
          <div class="scroller">
            <transition-group
              tag="div"
              name="items-slide"
              class="items"
              ref="items"
              :style="setSliderStyle"
            >
              <div class="item" v-for="img in images" :key="img" ref="items">
                <img
                  :src="getImage(img)"
                  :alt="
                    img
                      .split('.')
                      .slice(0, -1)
                      .join('.')
                  "
                />
              </div>
            </transition-group>
            <div class="range-container">
              <input
                type="range"
                min="0"
                max="100"
                value="0"
                class="range"
                ref="range"
              />
            </div>
          </div>
        </template>
      </base-scroll-animation>
    </div>
    <div class="buttons">
      <button
        class="arrow next"
        @click="
          prev();
          handleClear();
        "
      >
        <svg
          width="87px"
          height="84px"
          viewBox="0 0 87 84"
          version="1.1"
          xmlns="http://www.w3.org/2000/svg"
          xmlns:xlink="http://www.w3.org/1999/xlink"
        >
          <title>Group</title>
          <g
            id="Page-1"
            stroke="none"
            stroke-width="1"
            fill="none"
            fill-rule="evenodd"
          >
            <g
              id="Apple-TV-Copy"
              transform="translate(-1282.000000, -10047.000000)"
            >
              <g id="Group-7" transform="translate(0.000000, 9178.000000)">
                <g
                  id="Group-7-Copy"
                  transform="translate(409.000000, 869.000000)"
                >
                  <g id="Group" transform="translate(873.863521, 0.000000)">
                    <polygon
                      id="am_arrow_left-copy"
                      class="fill-class"
                      transform="translate(42.141653, 42.506024) scale(-1, 1) translate(-42.141653, -42.506024) "
                      points="36.8598012 24.2891566 51.5521346 39.0760472 20.2647088 39.0760472 20.2647088 45.6137745 51.6810074 45.6137745 36.7325967 60.7228916 45.7624511 60.7228916 64.018597 42.3773007 45.9680637 24.2891566"
                    ></polygon>
                    <ellipse
                      id="Oval"
                      class="stroke-class"
                      stroke-width="6.75"
                      cx="43.1591852"
                      cy="42"
                      rx="38.8525898"
                      ry="38.625"
                    ></ellipse>
                  </g>
                </g>
              </g>
            </g>
          </g>
        </svg>
        <!-- <img :src="getImage('circle-arrow-forward.svg')" alt="right arrow" /> -->
      </button>
      <button
        class="arrow prev"
        @click="
          next();
          handleClear();
        "
      >
        <!-- <img :src="getImage('circle-arrow-back.svg')" alt="right arrow" /> -->
        <svg
          width="86px"
          height="84px"
          viewBox="0 0 86 84"
          version="1.1"
          xmlns="http://www.w3.org/2000/svg"
          xmlns:xlink="http://www.w3.org/1999/xlink"
        >
          <title>Group Copy</title>
          <g
            id="Page-1"
            stroke="none"
            stroke-width="1"
            fill="none"
            fill-rule="evenodd"
          >
            <g
              id="Apple-TV-Copy"
              transform="translate(-1393.000000, -10047.000000)"
            >
              <g id="Group-7" transform="translate(0.000000, 9178.000000)">
                <g
                  id="Group-7-Copy"
                  transform="translate(409.000000, 869.000000)"
                >
                  <g
                    id="Group-Copy"
                    transform="translate(1027.265608, 42.000000) rotate(-180.000000) translate(-1027.265608, -42.000000) translate(984.765608, -0.000000)"
                  >
                    <polygon
                      id="am_arrow_left-copy"
                      class="fill-class"
                      transform="translate(41.464441, 42.506024) scale(-1, 1) translate(-41.464441, -42.506024) "
                      points="36.1825888 24.2891566 50.8749223 39.0760472 19.5874965 39.0760472 19.5874965 45.6137745 51.0037951 45.6137745 36.0553843 60.7228916 45.0852387 60.7228916 63.3413847 42.3773007 45.2908513 24.2891566"
                    ></polygon>
                    <ellipse
                      id="Oval"
                      class="stroke-class"
                      stroke-width="6.75"
                      cx="42.4819729"
                      cy="42"
                      rx="38.8525898"
                      ry="38.625"
                    ></ellipse>
                  </g>
                </g>
              </g>
            </g>
          </g>
        </svg>
      </button>
    </div>
  </article>
</template>

<script>
export default {
  data() {
    return {
      images: [
        "am_panther_copy.png",
        "AM_torsoe_3_copy.png",
        "am_tiger_dagger_1_copy.png",
        "am_pattern_1_copy.png",
        "am_reaper_1_copy.png",
        "am_sacred_heart_2_larger_copy.png",
        "am_snake_1_copy.png",
        "am_back_4_copy.png",
        "am_back_closeup_copy.png",
        "am_horses_copy.png"
      ],
      interval: null,
      setSliderStyle: { marginRight: null },
      parallaxStrength: null,
      parallaxOrigin: null,
      setSlidePosStyle: { transform: "translateX(" + 0 + ")" }
    };
  },
  created() {
    window.addEventListener("resize", () => {
      this.handleCarousel();
      this.handleParallax();
      this.handleScroll();
    });
    window.addEventListener("load", () => {
      this.handleCarousel();
      this.handleParallax();
      this.handleScroll();
    });
  },
  beforeUnmount() {
    window.removeEventListener("resize", () => {
      this.handleCarousel();
      this.handleParallax();
      this.handleScroll();
    });
    window.removeEventListener("load", () => {
      this.handleCarousel();
      this.handleParallax();
      this.handleScroll();
    });
  },
  mounted() {
    if (document.body.clientWidth > 600) {
      this.interval = setInterval(this.next, 3000);
    }
    this.handleCarousel();
    this.handleScroll();
    this.handleParallax();
  },

  methods: {
    handleScroll() {
      const scroll = this.$refs.range;
      const panel = this.$refs.items.$el;
      if (document.body.clientWidth <= 601) {
        scroll.oninput = function() {
          let total = panel.scrollWidth - panel.offsetWidth;
          let percentage = total * (this.value / 100);
          panel.scrollLeft = percentage;
        };

        panel.onscroll = function() {
          let panelWidth = panel.scrollWidth - panel.offsetWidth;
          let total = panel.scrollLeft / panelWidth;
          let percentage = total * 100;
          scroll.value = percentage;
        };
      }
    },
    handleParallax() {
      const win_width = document.body.clientWidth;
      if (win_width > 1024) {
        this.parallaxStrength = 400;
        this.parallaxOrigin = 110;
      } else if (win_width <= 1024 && win_width >= 600) {
        this.parallaxStrength = 220;
        this.parallaxOrigin = 120;
      }
    },
    handleCarousel() {
      if (document.body.clientWidth < 600) {
        this.handleClear();
      } else if (document.body.clientWidth > 650) {
        this.setMarginRight();
      }
    },

    handleClear() {
      clearInterval(this.interval);
    },

    getImage(path) {
      return require(`@/assets/img/${path}`);
    },

    setMarginRight() {
      this.setSliderStyle.marginRight = -this.$refs.items.clientWidth + "px";
    },

    next() {
      const first = this.images.shift();
      this.images.push(first);
    },
    prev() {
      const last = this.images.pop();
      this.images.unshift(last);
    }
  },
  computed: {
    slidePosition() {
      return "width:" + 100 / this.images.length + "%;";
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~@/assets/scss/config/_variables.scss";
@import "~@/assets/scss/globals/_colors.scss";
.range-container {
  width: 100%;
  padding: 0 10px;
  margin: 20px 0 87px;
  display: block;
  @media all and (min-width: 601px) {
    display: none;
  }
}
.slide-container {
  display: grid;
  grid-template-columns: auto;
  padding: 0;
  // padding: 0 10px 0 10px;
  margin: 12.689rem 0 0;
  @media all and (min-width: 414px) {
    margin: 16rem 0 0;
  }
  @media all and (min-width: 600px) {
    margin: 0 0 0 0;
    padding: 0 0 4.75rem 0;
  }
  @media all and (min-width: 800px) {
    padding: 0 0 18rem 0;
    // padding: 0 0 9rem 0;
  }
}

.title\:large {
  margin: 0 auto;
  text-align: left;
  font-size: 5rem;
  letter-spacing: normal;
  margin: 0 0 1.7rem 0;
  padding-left: 0.625rem;
  letter-spacing: -6.4px;
  @media all and (min-width: 601px) {
    padding-left: 0;
    margin: 0 0 2.44rem 4rem;
  }
  @media all and (min-width: 1130px) {
    margin: 0 0 4.2rem $section-pad-left;
    font-size: 9.4rem;
    letter-spacing: -3.75px;
  }
  @media all and (min-width: 1920px) {
    font-size: 12.5rem;
  }
}
.buttons {
  grid-column: 1/3;
  grid-row: 3/4;
  justify-content: center;
  align-items: flex-start;
  padding-top: 1rem;
  display: none;
  @media all and (min-width: 600px) {
    display: flex;
  }
}
button {
  padding: 0;
  background: transparent;
  outline: 0;
  border: 0;
  z-index: 2;
  cursor: pointer;

  // display: none;
  // @media all and (min-width: 600px) {
  //   display: block;
  // }
  &:first-of-type {
    padding-right: 0.75rem;
  }
  &:last-of-type {
    padding-left: 0.75rem;
  }
  svg {
    max-width: 2.75rem;
    height: auto;
    @media all and (min-width: 768px) {
      max-width: initial;
    }
  }
  .fill-class {
    fill: $black;
    transition: fill 0.3s ease-out;
  }
  .stroke-class {
    stroke: $black;
    transition: stroke 0.3s ease-out;
  }
  &:hover {
    // opacity: 0.6;
    .fill-class {
      fill: $orange;
    }
    .stroke-class {
      stroke: $orange;
    }
  }

  // &.is-hidden {
  //   opacity: 0;
  //   pointer-events: none;
  // }
}

// has display flex
// as part of base style
.slider {
  max-width: initial;
  scroll-behavior: smooth;
  grid-row: 2/3;
  grid-column: 1/3;
  z-index: 1;
  overflow-x: scroll;
  scrollbar-width: none;
  &::-webkit-scrollbar {
    width: 0;
    background: transparent;
    display: none;
  }

  @media all and (min-width: 600px) {
    overflow-x: visible;
  }
}

.scroller {
  display: flex;
  flex-direction: column;
  align-items: center;
  scroll-behavior: smooth;
  overflow-y: hidden;
  overflow-x: scroll;
  max-width: 100vw;
  scrollbar-width: none;
  &::-webkit-scrollbar {
    width: 0;
    background: transparent;
    display: none;
  }

  @media all and (min-width: 600px) {
    overflow-x: hidden;
  }

  @media all and (min-width: 1920px) {
    margin-left: 0;
  }
}

.items {
  display: flex;
  align-items: center;
  overflow-x: scroll;
  // margin-top: 2rem;
  // margin-bottom: 2rem;
  margin-left: -0.5rem;
  justify-content: space-between;
  // scroll-behavior: smooth;
  scrollbar-width: none;
  &::-webkit-scrollbar {
    width: 0;
    background: transparent;
    display: none;
  }
  @media all and (min-width: 601px) {
    margin-top: 2rem;
    justify-content: center;
    overflow: hidden;
    margin-top: 0;
    margin-bottom: 0;
    margin-left: 0;
  }
}
.item {
  flex-grow: 0;
  flex-shrink: 0;
  // flex-basis: 36rem;
  margin-left: 0;
  height: auto;
  object-fit: contain;
  transition: transform 0.3s ease-in-out;
  // padding: 0 1rem;
  flex-basis: 23rem;
  padding: 0 0.5rem;

  @media all and (min-width: 600px) {
    margin-bottom: 0;
  }
  @media all and (min-width: 414px) {
    flex-basis: 24rem;
  }
  @media all and (min-width: 768px) {
    // flex-basis: auto;
    min-width: 33rem;
    &:first-of-type {
      opacity: 0;
    }
    &:last-of-type {
      opacity: 0;
    }
  }
  @media all and (min-width: 1024px) {
    min-width: 43rem;
  }
  @media all and (min-width: 1280px) {
    flex-basis: 56rem;
  }

  img {
    width: 100%;
    object-fit: contain;

    @media all and (min-width: 768px) {
      max-height: 33rem;
    }
    @media all and (min-width: 1024px) {
      max-width: 43rem;
    }
    @media all and (min-width: 1280px) {
      max-height: initial;
      max-width: initial;
    }
  }
}
.icon-small {
  display: none;
  @media all and (min-width: 650px) {
    display: block;
    max-width: 3.5rem;
  }
  @media all and (min-width: 768px) {
    margin-left: 4.5rem;
  }
  @media all and (min-width: 1024px) {
    max-width: 4.25rem;
  }
  @media all and (min-width: 1920px) {
    max-width: 5.7rem;
  }
}
</style>
